import { EventEmitter, OnInit, QueryList, TemplateRef } from '@angular/core';
import { DataTableColumn, DataTableRow } from '../../';
import { DataTableCellEvent, DataTableHeaderEvent, DataTableParams, DataTableRowEvent, DataTableTranslations, RowCallback } from '../types';
export declare class DataTable implements DataTableParams, OnInit {
    indexColumnVisible: boolean;
    selectColumnVisible: boolean;
    expandColumnVisible: boolean;
    private _sortBy;
    private _sortAsc;
    private _offset;
    private _limit;
    private _items;
    private _scheduledReload;
    private _selectAllCheckbox;
    private _displayParams;
    private _reloading;
    private _resizeInProgress;
    selectedRow: DataTableRow;
    selectedRows: DataTableRow[];
    resizeLimit: number;
    itemCount: number;
    headerTitle: string;
    header: boolean;
    pagination: boolean;
    indexColumn: boolean;
    indexColumnHeader: string;
    rowColors: RowCallback;
    rowTooltip: RowCallback;
    selectColumn: boolean;
    multiSelect: boolean;
    substituteRows: boolean;
    expandableRows: boolean;
    translations: DataTableTranslations;
    selectOnRowClick: boolean;
    autoReload: boolean;
    showReloading: boolean;
    rowClick: EventEmitter<DataTableRowEvent>;
    rowDoubleClick: EventEmitter<DataTableRowEvent>;
    headerClick: EventEmitter<DataTableHeaderEvent>;
    cellClick: EventEmitter<DataTableCellEvent>;
    reload: EventEmitter<DataTableParams>;
    columns: QueryList<DataTableColumn>;
    rows: QueryList<DataTableRow>;
    expandTemplate: TemplateRef<any>;
    items: any[];
    sortBy: string;
    sortAsc: boolean;
    offset: number;
    limit: number;
    page: number;
    readonly lastPage: number;
    readonly reloading: boolean;
    readonly displayParams: DataTableParams;
    selectAllCheckbox: boolean;
    readonly columnCount: number;
    readonly substituteItems: {}[];
    getRowColor(item: any, index: number, row: DataTableRow): string;
    sort(sortBy: string, asc: boolean): void;
    reloadItems(): void;
    rowClicked(row: DataTableRow, event: MouseEvent): void;
    rowDoubleClicked(row: DataTableRow, event: MouseEvent): void;
    headerClicked(column: DataTableColumn, event: MouseEvent): void;
    cellClicked(column: DataTableColumn, row: DataTableRow, event: MouseEvent): void;
    onRowSelectChanged(row: DataTableRow): void;
    resizeColumnStart(event: MouseEvent, column: DataTableColumn, columnElement: HTMLElement): void;
    ngOnInit(): void;
    private _initDefaultValues();
    private _initDefaultClickEvents();
    private _onReloadFinished();
    private _updateDisplayParams();
    private _triggerReload();
    private _getRemoteParameters();
    private _sortColumn(column);
    private _onSelectAllChanged(value);
    private _isResizeInLimit(columnElement, dx);
}
